halapi hierarchichalalignmentformatapi

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Pages
Public Member Functions | Friends | List of all members
hal::GappedTopSegmentIterator Class Referenceabstract

`#include <halGappedTopSegmentIterator.h>`

Inheritance diagram for hal::GappedTopSegmentIterator:

## Public Member Functions
virtual GappedTopSegmentIteratorPtr | copy ()=0
virtual GappedTopSegmentIteratorConstPtr | copy () const =0
virtual void | copy (GappedTopSegmentIteratorConstPtr ts) const =0
virtual void | toChild (GappedBottomSegmentIteratorConstPtr bs) const =0
virtual bool | equals (GappedTopSegmentIteratorConstPtr other) const =0
virtual bool | adjacentTo (GappedTopSegmentIteratorConstPtr other) const =0
virtual bool | hasParent () const =0
virtual bool | hasNextParalogy () const =0
virtual void | toNextParalogy () const =0
virtual bool | getParentReversed () const =0
virtual TopSegmentIteratorConstPtr | getLeft () const =0
virtual TopSegmentIteratorConstPtr | getRight () const =0
virtual void | setLeft (TopSegmentIteratorConstPtr ts) const =0
virtual bool | isCanonicalParalog () const =0
Public Member Functions inherited from hal::GappedSegmentIterator
virtual hal_size_t | getGapThreshold () const =0
virtual bool | getAtomic () const =0
virtual hal_size_t | getChildIndex () const =0
virtual hal_size_t | getNumSegments () const =0
virtual hal_size_t | getNumGaps () const =0
virtual hal_size_t | getNumGapBases () const =0
virtual hal_index_t | getLeftArrayIndex () const =0
virtual hal_index_t | getRightArrayIndex () const =0
Public Member Functions inherited from hal::SegmentIterator
virtual void | toLeft (hal_index_t leftCutoff=NULL_INDEX) const =0
virtual void | toRight (hal_index_t rightCutoff=NULL_INDEX) const =0
virtual void | toSite (hal_index_t position, bool slice=true) const =0
Public Member Functions inherited from hal::SlicedSegment
virtual void | toReverse () const =0
virtual void | toReverseInPlace () const =0
virtual hal_offset_t | getStartOffset () const =0
virtual hal_offset_t | getEndOffset () const =0
virtual void | slice (hal_offset_t startOffset=0, hal_offset_t endOffset=0) const =0
virtual bool | getReversed () const =0
Public Member Functions inherited from hal::Segment
virtual void | setArrayIndex (Genome *genome, hal_index_t arrayIndex)=0
virtual void | setArrayIndex (const Genome *genome, hal_index_t arrayIndex) const =0
virtual const Genome * | getGenome () const =0
virtual Genome * | getGenome ()=0
virtual const Sequence * | getSequence () const =0
virtual Sequence * | getSequence ()=0
virtual hal_index_t | getStartPosition () const =0
virtual hal_index_t | getEndPosition () const =0
virtual hal_size_t | getLength () const =0
virtual void | getString (std::string &outString) const =0
virtual void | setCoordinates (hal_index_t startPos, hal_size_t length)=0
virtual hal_index_t | getArrayIndex () const =0
virtual bool | leftOf (hal_index_t genomePos) const =0
virtual bool | rightOf (hal_index_t genomePos) const =0
virtual bool | overlaps (hal_index_t genomePos) const =0
virtual bool | isFirst () const =0
virtual bool | isLast () const =0
virtual bool | isMissingData (double nThreshold) const =0
virtual bool | isTop () const =0
virtual hal_size_t | getMappedSegments (std::set< MappedSegmentConstPtr > &outSegments, const Genome *tgtGenome, const std::set< const Genome * > *genomesOnPath=NULL, bool doDupes=true, hal_size_t minLength=0) const =0
virtual void | print (std::ostream &os) const =0

## Friends
class | counted_ptr< GappedTopSegmentIterator >
class | counted_ptr< const GappedTopSegmentIterator >

## Detailed Description

Interface for Gepped Top Segment iterator. Only used internally and probably shouldn't be in public interface.

## Member Function Documentation

virtual bool hal::GappedTopSegmentIterator::adjacentTo | ( | GappedTopSegmentIteratorConstPtr | other | ) | const
| pure virtual

Test if iterator abuts other iterator

virtual GappedTopSegmentIteratorPtr hal::GappedTopSegmentIterator::copy | ( |  | ) |
| pure virtual

Return a copy of the iterator

virtual GappedTopSegmentIteratorConstPtr hal::GappedTopSegmentIterator::copy | ( |  | ) | const
| pure virtual

Return a copy of the iterator

virtual void hal::GappedTopSegmentIterator::copy | ( | GappedTopSegmentIteratorConstPtr | ts | ) | const
| pure virtual

Copy another iterator into the current iterator (more efficient than above methods since no new iterators are created

virtual bool hal::GappedTopSegmentIterator::equals | ( | GappedTopSegmentIteratorConstPtr | other | ) | const
| pure virtual

Test equality with other iterator

Parameters

  other |

virtual TopSegmentIteratorConstPtr hal::GappedTopSegmentIterator::getLeft | ( |  | ) | const
| pure virtual

Return the leftmost segment of the iterator (note that moving the returned iterator will corrupt the current gapped iterator. this is a bug)

virtual bool hal::GappedTopSegmentIterator::getParentReversed | ( |  | ) | const
| pure virtual

Test if in reverse orientationt with respect to parent

virtual TopSegmentIteratorConstPtr hal::GappedTopSegmentIterator::getRight | ( |  | ) | const
| pure virtual

Return the rightmost segment of the iterator (note that moving the returned iterator will corrupt the current gapped iterator. this is a bug)

virtual bool hal::GappedTopSegmentIterator::hasNextParalogy | ( |  | ) | const
| pure virtual

Test if iterator has a duplicate

virtual bool hal::GappedTopSegmentIterator::hasParent | ( |  | ) | const
| pure virtual

Test if iterator has a parent

virtual bool hal::GappedTopSegmentIterator::isCanonicalParalog | ( |  | ) | const
| pure virtual

For every set of paralogous top segments in a given genome, we identify a unique segment as the canonical reference. This is the segment that will be traversed when disabling duplication edges when mapping via the column iterator or mappedSegment interface. It is also the segment that is connected from its parent's down edge.

virtual void hal::GappedTopSegmentIterator::setLeft | ( | TopSegmentIteratorConstPtr | ts | ) | const
| pure virtual

Reset the gapped iterator.

Parameters

  ts | This will be the left segment of the current iterator. The right segment will be extended as far as possible

virtual void hal::GappedTopSegmentIterator::toChild | ( | GappedBottomSegmentIteratorConstPtr | bs | ) | const
| pure virtual

Move to child of given iterator

Parameters

  bs | Move to child of this iterator

virtual void hal::GappedTopSegmentIterator::toNextParalogy | ( |  | ) | const
| pure virtual

Move to next paralogy

The documentation for this class was generated from the following file:

- inc/halGappedTopSegmentIterator.h